'FFSubmenu=Tools
'FFName=Zeichenersatz

'(c) Harald Maeckler, Dsseldorf 2018
' ***********************************************************************
' Zeichenersatz.vbs (Skript fr FixFoto)
' Zeichen in Bildernamen suchen und ersetzen durch andere Zeichen
' ***********************************************************************
'
' Version 1.01 vom 27.03.2018	- Auswahl erweitert um 'alle Dateien im aktiven Odner und dessen Unterordner'
'								- Kurzbeschreibung
'								- Updatefunktion
' Version 1.00 vom 23.03.2018	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.01"
const SkriptURL = "http://www.ffsf.de/resources/dpi-checker.249/"	'###
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
const AWtexte = "alle Bilder des Computerverzeichnis|markierte Bilder des Computerverzeichnis|alle Bilder der aktiven Bilderliste|markierte Bilder der aktiven Bilderliste|Dateien des Computerverz.mit Unterordner"
Dim AWarray,Auswahl

'Such- und Ersatzparameter und andere
const Bildfilter = ".JPG.JPEG.JP2.PNG.TIF.BMP"
Dim objFolder,Bildsammlung,bild_array,Anz,Unterordner,OrdAnz,Datei
Dim SZ 'Suchzeichen
Dim EZ 'Ersatzzeichen

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Zeichenersatz"						'Skriptname
const RegSchluessel = "FF_Zeichenersatz"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Zeichenersatz **
FF_AddDialog "Zeichenersatz",212,76
FF_AddControl "Zeichenersatz","Auswahl","GROUP",5,5,122,36
FF_AddControl "Zeichenersatz","Such- und Ersatzparameter","GROUP",132,5,76,36
FF_AddControl "Zeichenersatz","Bilderauswahl","COMBO",9,15,114,10
FF_AddControl "Zeichenersatz","||","STATIC",8,27,118,10
FF_SetControlStyle "Zeichenersatz","||",1
FF_AddControl "Zeichenersatz","Suchzeichen","STATIC",140,15,35,10
FF_AddControl "Zeichenersatz","SZ","SLEDIT",180,15,20,10
FF_SetControlStyle "Zeichenersatz","SZ",1
FF_AddControl "Zeichenersatz","Ersatzzeichen","STATIC",140,27,35,10
FF_AddControl "Zeichenersatz","EZ","SLEDIT",180,27,20,10
FF_SetControlStyle "Zeichenersatz","EZ",1
FF_AddControl "Zeichenersatz","Fortschritt","PROGRESS",5,47,203,4
FF_AddControl "Zeichenersatz","|","STATIC",18,59,22,11
FF_SetControlStyle "Zeichenersatz","|",1
FF_AddControl "Zeichenersatz","Abbrechen","BUTTON",139,59,33,11
FF_AddControl "Zeichenersatz","Start","BUTTON",175,59,33,11
FF_AddControl "Zeichenersatz","&delete","BUTTON",0,0,1,1
FF_AddControl "Zeichenersatz","?","BUTTON",5,59,11,11
FF_AddControl "Zeichenersatz","Update","BUTTON",42,59,33,11
FF_AddControl "Zeichenersatz","Abbruch mit","STATIC",90,54,33,8
FF_AddControl "Zeichenersatz","Taste","STATIC",85,63,17,8
FF_AddControl "Zeichenersatz","Backspace","BUTTON",100,63,30,8
'** End Dialog Zeichenersatz **

AWarray = split(AWtexte,"|")
for Auswahl = 0 to ubound(AWarray)
	FF_SetControl "Zeichenersatz","Bilderauswahl",AWarray(Auswahl)
next

call RegistryLesen
if Auswahl = 4 then
	call Ordneranzahl
else
	call Bildanzahl
end if

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Zeichenersatz","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Zeichenersatz","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Zeichenersatz","Backspace", "" &_
						 "Laufende Bearbeitung mit" & vbNewLine &_
						 "Taste 'Backspace' abbrechen"
	FF_SetControlTooltip "Zeichenersatz","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "Zeichenersatz","Start", "" &_
						 "Starten der Anwendung"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_SetDialogTimer "Zeichenersatz", 100
FF_ActivateControl "Zeichenersatz","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("Zeichenersatz")
	Case "TIMER"
		if Auswahl = 4 then
			FF_SetControl "Zeichenersatz" ,"||", "alle Bilder in " & OrdAnz & " Verzeichnissen"
		else
			FF_SetControl "Zeichenersatz" ,"||", Anz & " Bilder"
		end if
		FF_SetControl "Zeichenersatz" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Zeichenersatz", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Bilderauswahl"
		call Werte_auslesen
		if Auswahl = 4 then
			call Ordneranzahl
			FF_SetControl "Zeichenersatz" ,"||", "alle Bilder in " & OrdAnz & " Verzeichnisse"
		else
			call Bildanzahl
			FF_SetControl "Zeichenersatz" ,"||", Anz & " Bilder"
		end if
	Case "?"
		'FF_SetControl "Zeichenersatz","Fortschritt",65	'############## nur fr Screenshot
		WshShell.Popup "" & _
			"Allgemein" & vbNewLine &_
			"-------------" & vbNewLine &_
			"Das Skript dient dazu, in Dateinamen Zeichen zu suchen" & vbNewLine &_
			"und diese durch andere Zeichen zu ersetzen." & vbNewLine & vbNewLine &_
			"Auswahl" & vbNewLine &_
			"-----------" & vbNewLine &_
			"Hier wird bestimmt, bei welchen Dateien Zeichen ersetzt" & vbNewLine &_
			"werden sollen. Es handelt sich immer um von FixFoto er-" & vbNewLine &_
			"kannte Dateien mit einer Ausnahme. Bei der Wahl" & vbNewLine &_
			"    'Dateien des Computerverz. mit Unterordner'" & vbNewLine &_
			"werden alle Dateien, unabhngig davon um welchen" & vbNewLine &_
			"Dateityp es sich handelt, bearbeitet." & vbNewLine & vbNewLine &_
			"Update" & vbNewLine &_
			"----------" & vbNewLine &_
			"Es wird berprft, ob eine hhere Skriptversion vorliegt." & vbNewLine &_
			"Voraussetzung ist eine bestehende Internetverbindung." & vbNewLine & vbNewLine &_
			"Skript lschen" & vbNewLine &_
			"-------------------" & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr" & vbNewLine &_
			"das Skript eine Lschroutine aufgerufen werden." & vbNewLine &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "Abbrechen","CANCEL"
		exit do
	Case "Start"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			if Abbruch then exit do
		end if

	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Zeichenersatz")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Schleife
Dim AnzB,n,Nneu,msg
Dim sDir,sBaseName,sExt

if Auswahl = 4 then
	Antwort = msgbox("Je nach Anzahl der Unterordner kann" & vbNewLine &_
					 "die Ermittlung der Dateien mehrere" & vbNewLine &_
					 "Minuten dauern.",vbOkCancel + vbQuestion,"Abfrage")
	if Antwort = vbCancel then exit sub
end if

AnzB = 0
call Bildanzahl
if Anz = 0 then
	msgbox "Im Computerverzeichnis sind keine Dateien" & vbNewLine &_
		   "markiert bzw. vorhanden!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

if SZ = " " then msg = "Leerzeichen" else msg = chr(34) & SZ & chr(34)
if EZ = "" then
	msg = msg & " werden gelscht!"
else
	msg = msg & " werden ersetzt durch " & chr(34) & EZ & chr(34)
end if
Antwort = msgbox(msg & vbNewLine & vbNewLine & "Ist das so gewollt?",vbYesNo,"Abfrage")
if Antwort = vbNo then exit sub

For n = 0 to Anz -1
	
	'Verzeichnis extrahieren
	sDir = objFS.GetParentFolderName(bild_Array(n))
	'Basisnamen ohne Dateityp extrahieren
	sBaseName = objFS.GetBaseName(bild_Array(n))
	'Erweiterung extrahieren
	sExt = objFS.GetExtensionName(bild_Array(n))
	
'	'nur Dateien, die dem Bildfilter entsprechen, werden angenommen
'   if instr(Bildfilter,"." & ucase(sExt)) > 0 then
		Nneu = Replace(sBaseName,SZ,EZ)
		objFS.CopyFile bild_Array(n), sDir & "\" & Nneu & "." & sExt, True
		if sBaseName <> Nneu then
			objFS.DeleteFile bild_Array(n),true
			AnzB = AnzB +1
		end if
'	end if

	'### Fortschrittsanzeige
	FF_SetControl "Zeichenersatz","Fortschritt",(n +1)/Anz*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Dateien wurden bisher " & n +1 & " Dateien bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
next

msgbox "Von " & Anz & " Dateien wurden " & AnzB & " bearbeitet.",vbInformation,"Schlussmeldung"
Abbruch = true

End Sub
'------------------------------------------------------------------------
Sub Bildanzahl
'Ermittlung der Anzahl der zu bearbeitenden Bilder

if Auswahl = 4 then
	Set objFolder = objFS.GetFolder(FF_GetImagePath)
	Bildsammlung = ""
	call AlleOrdner(objFolder)
	bild_array = split(Bildsammlung,vbNewline)
	Anz = ubound(bild_Array) +1
else
	Bildsammlung = FF_GetSelection(Auswahl)
	bild_array = split(Bildsammlung,vbNewline)
	Anz = ubound(bild_Array) +1
end if

End Sub
'------------------------------------------------------------------------
Sub Ordneranzahl

Set objFolder = objFS.GetFolder(FF_GetImagePath)
OrdAnz = 0
call AlleUnterordner(objFolder)

End Sub
'------------------------------------------------------------------------
Sub AlleOrdner(ByVal Startordner)
'Bildsammlung der Dateien in allen Ordnern
 
for each Datei In Startordner.Files
    if Bildsammlung = "" then
        Bildsammlung = Datei
    else
        Bildsammlung = Bildsammlung & vbNewLine & Datei
    end if
next
 
For Each Unterordner In Startordner.subfolders
    AlleOrdner Unterordner
Next
 
End Sub
'------------------------------------------------------------------------
Sub AlleUnterordner(ByVal Startordner)
'Anzahl der Verzeichnisse

OrdAnz = OrdAnz +1

For Each Unterordner In Startordner.subfolders
    AlleUnterordner Unterordner
Next

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen

Dim AuswahlWert

'Auswahl
'0 = alle Bilder des Computerverzeichnis
'1 = selekt. Bilder des Computerverzeichnis
'2 = alle Bilder der Bilderliste
'3 = selektierte Bilder der Bilderliste
'4 = Bilder des Computerverz. mit Unterordnern

AuswahlWert = FF_GetControl("Zeichenersatz","Bilderauswahl")
for Auswahl = 0 to ubound(AWarray)
	if AWarray(Auswahl) = Auswahlwert then exit for
next
Auswahl = Auswahl *1

SZ = FF_GetControl("Zeichenersatz","SZ")
EZ = FF_GetControl("Zeichenersatz","EZ")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if not Zeichentest(SZ) then
	msgbox "Die Zeichen \ ,/ ,: ,* ,? ,< ,> ,| ,"""" und ," & vbNewline &_
	"knnen im Bildnamen nicht vorkommen!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if not Zeichentest(EZ) then
	msgbox "Die Zeichen \ ,/ ,: ,* ,? ,< ,> ,| ,"""" und ," & vbNewline &_
	"sind nicht erlaubt!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if SZ = "" then
	msgbox "Es muss ein Suchzeichen eingetragen werden!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 0
Auswahl = Auswahl *1

'Parameter
SZ = FF_GetProfile (RegSchluessel,"SZ")
if SZ = "" then SZ = "."
EZ = FF_GetProfile (RegSchluessel,"EZ")
if EZ = "" then EZ = "_"

'### Werte eintragen

'Auswahl
FF_SetControl "Zeichenersatz","Bilderauswahl",AWarray(Auswahl)
FF_SetControl "Zeichenersatz","SZ",SZ
FF_SetControl "Zeichenersatz","EZ",EZ

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl
FF_WriteProfile RegSchluessel,"SZ",SZ
FF_WriteProfile RegSchluessel,"EZ",EZ

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Zeichentest (strDName)
Dim y,z
	z = split("\,/,:,*,?,<,>,|" & chr(34),",")
	for each y in z
		if instr(strDName,y) > 0 then
			Zeichentest = false
			exit Function
		end if
	next
	Zeichentest = true
End Function
'------------------------------------------------------------------------
